<template>
<div v-if="!value || !value.length" class="no_data">No bookmarks</div>
<el-collapse v-else v-model="opened" @change="handleChange">
    <el-collapse-item v-for="obj in bookmarks" :key="obj.company_id" :name="obj.company_id" class="bookmark">
        <template v-slot:title>
            <div :class="headerClass(obj.company_id)">
                {{title(obj.company_name)}}
                <template v-if="isEditable">
                     <i :class="iconView(obj.company_id)" @click.stop="switchDelete(obj.company_id)"></i>
                </template>
            </div>
        </template>
        <bookmark
            :company-id="obj.company_id"
            :company-link="obj.company_link"
            :company-name="obj.company_name"
            :company-site="obj.company_site"
            :date="obj.date"/>
    </el-collapse-item>
</el-collapse>
</template>

<script>
import Bookmark from '@/components/Bookmarks/Bookmark';

export default {
    components: {
        Bookmark,
    },
    props: {
        /** server id for bookmarks */
        id: {
            type: String,
            required: false,
            default: 'bookmarks',
        },
        /** current active bookmarks */
        value: {
            type: [Array, String],
            required: true,
        },
    },
    watch: {
        value(newVal) {
            this.bookmarks = [...newVal];
        },
    },
    data() {
        return {
            bookmarks: [...this.value],
            opened: [],
        };
    },
    computed: {
        title: () => (name) => {
            if (!name) {
                return '[company name not set]';
            }
            return name;
        },
        isEditable: vm => vm.$store.getters.isEditable(vm.id),
        bookmarkById: vm => id => vm.bookmarks.find(b => b.company_id === id),
        isDeleted: vm => id => vm.$store.getters.isBookmarkDeleted(id),
        iconView: vm => id => (vm.isDeleted(id) ? 'el-icon-refresh' : 'el-icon-delete'),
        headerClass: vm => id => ({ header_common: true, header_deleted: vm.isDeleted(id) }),
    },
    methods: {
        /**
         * Deleting of bookmark
         * @param {Number} id - bookmark id
         */
        switchDelete(id) {
            if (this.isDeleted(id)) {
                this.$store.commit('removeDeletedBookmark', id);
            } else {
                this.$store.commit('addDeletedBookmark', id);
                this.handleChange();
            }
        },
        /**
         * Handler for changing open status of bookmark collapse section
         * @param {Array} val - current opened sections
         */
        handleChange(val = null) {
            // don't open section of deleted bookmark
            const currentOpened = !val ? this.opened : val;
            this.opened = currentOpened.filter(id => !this.isDeleted(id));
        },
        /**
         * Discard changes for bookmarks: restore deleted bookmarks
         */
        discardChanges() {
            this.$store.commit('clearDeletedBookmarks');
        },
    },
};
</script>

<style lang="stylus" scoped>
.bookmark
    margin: 1rem

>>> .el-collapse-item__header
    color: $dark_gray !important

.el-icon-delete, .el-icon-refresh
    vertical-align: middle
    float: right
    line-height: 48px
    margin-right: 2rem
    color: $base_blue

.el-icon-refresh
    color: $dark_gray
    font-size: 2rem

.el-icon-delete:hover, .el-icon-refresh:hover
    color: $title_blue

.header_deleted
    text-decoration: line-through !important
    color: $base_gray

.header_common
    width: 100%
    text-decoration: none

</style>
